libidn: idna.h File Reference

libidn 1.42

Macros | Enumerations | Functions
idna.h File Reference
`#include <stddef.h>`
`#include <idn-int.h>`

Go to the source code of this file.

## Macros
#define | IDNAPI
#define | IDNA_ACE_PREFIX "xn--"

## Enumerations
enum | Idna_rc { IDNA_SUCCESS = 0 , IDNA_STRINGPREP_ERROR = 1 , IDNA_PUNYCODE_ERROR = 2 , IDNA_CONTAINS_NON_LDH = 3 , IDNA_CONTAINS_LDH = IDNA_CONTAINS_NON_LDH , IDNA_CONTAINS_MINUS = 4 , IDNA_INVALID_LENGTH = 5 , IDNA_NO_ACE_PREFIX = 6 , IDNA_ROUNDTRIP_VERIFY_ERROR = 7 , IDNA_CONTAINS_ACE_PREFIX = 8 , IDNA_ICONV_ERROR = 9 , IDNA_MALLOC_ERROR = 201 , IDNA_DLOPEN_ERROR = 202 }
enum | Idna_flags { IDNA_ALLOW_UNASSIGNED = 0x0001 , IDNA_USE_STD3_ASCII_RULES = 0x0002 }

## Functions
IDNAPI const char * | idna_strerror (Idna_rc rc)
IDNAPI int | idna_to_ascii_4i (const uint32_t *in, size_t inlen, char *out, int flags)
IDNAPI int | idna_to_unicode_44i (const uint32_t *in, size_t inlen, uint32_t *out, size_t *outlen, int flags)
IDNAPI int | idna_to_ascii_4z (const uint32_t *input, char **output, int flags)
IDNAPI int | idna_to_ascii_8z (const char *input, char **output, int flags)
IDNAPI int | idna_to_ascii_lz (const char *input, char **output, int flags)
IDNAPI int | idna_to_unicode_4z4z (const uint32_t *input, uint32_t **output, int flags)
IDNAPI int | idna_to_unicode_8z4z (const char *input, uint32_t **output, int flags)
IDNAPI int | idna_to_unicode_8z8z (const char *input, char **output, int flags)
IDNAPI int | idna_to_unicode_8zlz (const char *input, char **output, int flags)
IDNAPI int | idna_to_unicode_lzlz (const char *input, char **output, int flags)

## Macro Definition Documentation

## ◆ IDNA_ACE_PREFIX

#define IDNA_ACE_PREFIX "xn--"

Definition at line 99 of file idna.h.

## ◆ IDNAPI

#define IDNAPI

SECTION:idna

Parameters

  title | idna.h
  short_description | IDNA-related functions

IDNA-related functions. IDNAPI:

Symbol holding shared library API visibility decorator.

This is used internally by the library header file and should never be used or modified by the application.

https://www.gnu.org/software/gnulib/manual/html_node/Exported-Symbols-of-Shared-Libraries.html

Definition at line 59 of file idna.h.

## Enumeration Type Documentation

## ◆ Idna_flags

enum Idna_flags

Enumerator
IDNA_ALLOW_UNASSIGNED |
IDNA_USE_STD3_ASCII_RULES |

Definition at line 92 of file idna.h.

## ◆ Idna_rc

enum Idna_rc

Enumerator
IDNA_SUCCESS |
IDNA_STRINGPREP_ERROR |
IDNA_PUNYCODE_ERROR |
IDNA_CONTAINS_NON_LDH |
IDNA_CONTAINS_LDH |
IDNA_CONTAINS_MINUS |
IDNA_INVALID_LENGTH |
IDNA_NO_ACE_PREFIX |
IDNA_ROUNDTRIP_VERIFY_ERROR |
IDNA_CONTAINS_ACE_PREFIX |
IDNA_ICONV_ERROR |
IDNA_MALLOC_ERROR |
IDNA_DLOPEN_ERROR |

Definition at line 72 of file idna.h.

## Function Documentation

## ◆ idna_strerror()

IDNAPI const char * idna_strerror | ( | Idna_rc | rc | ) |

idna_strerror:

Parameters

  rc | an Idna_rc return code.

Convert a return code integer to a text string. This string can be used to output a diagnostic message to the user.

IDNA_SUCCESS: Successful operation. This value is guaranteed to always be zero, the remaining ones are only guaranteed to hold non-zero values, for logical comparison purposes. IDNA_STRINGPREP_ERROR: Error during string preparation. IDNA_PUNYCODE_ERROR: Error during punycode operation. IDNA_CONTAINS_NON_LDH: For IDNA_USE_STD3_ASCII_RULES, indicate that the string contains non-LDH ASCII characters. IDNA_CONTAINS_MINUS: For IDNA_USE_STD3_ASCII_RULES, indicate that the string contains a leading or trailing hyphen-minus (U+002D). IDNA_INVALID_LENGTH: The final output string is not within the (inclusive) range 1 to 63 characters. IDNA_NO_ACE_PREFIX: The string does not contain the ACE prefix (for ToUnicode). IDNA_ROUNDTRIP_VERIFY_ERROR: The ToASCII operation on output string does not equal the input. IDNA_CONTAINS_ACE_PREFIX: The input contains the ACE prefix (for ToASCII). IDNA_ICONV_ERROR: Character encoding conversion error. IDNA_MALLOC_ERROR: Could not allocate buffer (this is typically a fatal error). IDNA_DLOPEN_ERROR: Could not dlopen the libcidn DSO (only used internally in libc).

Return value: Returns a pointer to a statically allocated string containing a description of the error with the return code @rc.

Definition at line 73 of file strerror-idna.c.

## ◆ idna_to_ascii_4i()

IDNAPI int idna_to_ascii_4i | ( | const uint32_t * | in,
|  | size_t | inlen,
|  | char * | out,
|  | int | flags
| ) |  |

idna_to_ascii_4i:

Parameters

  in | input array with unicode code points.
  inlen | length of input array with unicode code points.
  out | output zero terminated string that must have room for at least 63 characters plus the terminating zero.
  flags | an Idna_flags value, e.g., IDNA_ALLOW_UNASSIGNED or IDNA_USE_STD3_ASCII_RULES.

The ToASCII operation takes a sequence of Unicode code points that make up one domain label and transforms it into a sequence of code points in the ASCII range (0..7F). If ToASCII succeeds, the original sequence and the resulting sequence are equivalent labels.

It is important to note that the ToASCII operation can fail. ToASCII fails if any step of it fails. If any step of the ToASCII operation fails on any label in a domain name, that domain name MUST NOT be used as an internationalized domain name. The method for deadling with this failure is application-specific.

The inputs to ToASCII are a sequence of code points, the AllowUnassigned flag, and the UseSTD3ASCIIRules flag. The output of ToASCII is either a sequence of ASCII code points or a failure condition.

ToASCII never alters a sequence of code points that are all in the ASCII range to begin with (although it could fail). Applying the ToASCII operation multiple times has exactly the same effect as applying it just once.

Return value: Returns 0 on success, or an Idna_rc error code.

Definition at line 81 of file idna.c.

## ◆ idna_to_ascii_4z()

IDNAPI int idna_to_ascii_4z | ( | const uint32_t * | input,
|  | char ** | output,
|  | int | flags
| ) |  |

idna_to_ascii_4z:

Parameters

  input | zero terminated input Unicode string.
  output | pointer to newly allocated output string.
  flags | an Idna_flags value, e.g., IDNA_ALLOW_UNASSIGNED or IDNA_USE_STD3_ASCII_RULES.

Convert UCS-4 domain name to ASCII string. The domain name may contain several labels, separated by dots. The output buffer must be deallocated by the caller.

Return value: Returns IDNA_SUCCESS on success, or error code.

Definition at line 477 of file idna.c.

## ◆ idna_to_ascii_8z()

IDNAPI int idna_to_ascii_8z | ( | const char * | input,
|  | char ** | output,
|  | int | flags
| ) |  |

idna_to_ascii_8z:

Parameters

  input | zero terminated input UTF-8 string.
  output | pointer to newly allocated output string.
  flags | an Idna_flags value, e.g., IDNA_ALLOW_UNASSIGNED or IDNA_USE_STD3_ASCII_RULES.

Convert UTF-8 domain name to ASCII string. The domain name may contain several labels, separated by dots. The output buffer must be deallocated by the caller.

Return value: Returns IDNA_SUCCESS on success, or error code.

Definition at line 576 of file idna.c.

## ◆ idna_to_ascii_lz()

IDNAPI int idna_to_ascii_lz | ( | const char * | input,
|  | char ** | output,
|  | int | flags
| ) |  |

idna_to_ascii_lz:

Parameters

  input | zero terminated input string encoded in the current locale's character set.
  output | pointer to newly allocated output string.
  flags | an Idna_flags value, e.g., IDNA_ALLOW_UNASSIGNED or IDNA_USE_STD3_ASCII_RULES.

Convert domain name in the locale's encoding to ASCII string. The domain name may contain several labels, separated by dots. The output buffer must be deallocated by the caller.

Return value: Returns IDNA_SUCCESS on success, or error code.

Definition at line 609 of file idna.c.

## ◆ idna_to_unicode_44i()

IDNAPI int idna_to_unicode_44i | ( | const uint32_t * | in,
|  | size_t | inlen,
|  | uint32_t * | out,
|  | size_t * | outlen,
|  | int | flags
| ) |  |

idna_to_unicode_44i:

Parameters

  in | input array with unicode code points.
  inlen | length of input array with unicode code points.
  out | output array with unicode code points.
  outlen | on input, maximum size of output array with unicode code points, on exit, actual size of output array with unicode code points.
  flags | an Idna_flags value, e.g., IDNA_ALLOW_UNASSIGNED or IDNA_USE_STD3_ASCII_RULES.

The ToUnicode operation takes a sequence of Unicode code points that make up one domain label and returns a sequence of Unicode code points. If the input sequence is a label in ACE form, then the result is an equivalent internationalized label that is not in ACE form, otherwise the original sequence is returned unaltered.

ToUnicode never fails. If any step fails, then the original input sequence is returned immediately in that step.

The Punycode decoder can never output more code points than it inputs, but Nameprep can, and therefore ToUnicode can. Note that the number of octets needed to represent a sequence of code points depends on the particular character encoding used.

The inputs to ToUnicode are a sequence of code points, the AllowUnassigned flag, and the UseSTD3ASCIIRules flag. The output of ToUnicode is always a sequence of Unicode code points.

Return value: Returns Idna_rc error condition, but it must only be used for debugging purposes. The output buffer is always guaranteed to contain the correct data according to the specification (sans malloc induced errors). NB! This means that you normally ignore the return code from this function, as checking it means breaking the standard.

Definition at line 437 of file idna.c.

## ◆ idna_to_unicode_4z4z()

IDNAPI int idna_to_unicode_4z4z | ( | const uint32_t * | input,
|  | uint32_t ** | output,
|  | int | flags
| ) |  |

idna_to_unicode_4z4z:

Parameters

  input | zero-terminated Unicode string.
  output | pointer to newly allocated output Unicode string.
  flags | an Idna_flags value, e.g., IDNA_ALLOW_UNASSIGNED or IDNA_USE_STD3_ASCII_RULES.

Convert possibly ACE encoded domain name in UCS-4 format into a UCS-4 string. The domain name may contain several labels, separated by dots. The output buffer must be deallocated by the caller.

Return value: Returns IDNA_SUCCESS on success, or error code.

Definition at line 640 of file idna.c.

## ◆ idna_to_unicode_8z4z()

IDNAPI int idna_to_unicode_8z4z | ( | const char * | input,
|  | uint32_t ** | output,
|  | int | flags
| ) |  |

idna_to_unicode_8z4z:

Parameters

  input | zero-terminated UTF-8 string.
  output | pointer to newly allocated output Unicode string.
  flags | an Idna_flags value, e.g., IDNA_ALLOW_UNASSIGNED or IDNA_USE_STD3_ASCII_RULES.

Convert possibly ACE encoded domain name in UTF-8 format into a UCS-4 string. The domain name may contain several labels, separated by dots. The output buffer must be deallocated by the caller.

Return value: Returns IDNA_SUCCESS on success, or error code.

Definition at line 719 of file idna.c.

## ◆ idna_to_unicode_8z8z()

IDNAPI int idna_to_unicode_8z8z | ( | const char * | input,
|  | char ** | output,
|  | int | flags
| ) |  |

idna_to_unicode_8z8z:

Parameters

  input | zero-terminated UTF-8 string.
  output | pointer to newly allocated output UTF-8 string.
  flags | an Idna_flags value, e.g., IDNA_ALLOW_UNASSIGNED or IDNA_USE_STD3_ASCII_RULES.

Convert possibly ACE encoded domain name in UTF-8 format into a UTF-8 string. The domain name may contain several labels, separated by dots. The output buffer must be deallocated by the caller.

Return value: Returns IDNA_SUCCESS on success, or error code.

Definition at line 750 of file idna.c.

## ◆ idna_to_unicode_8zlz()

IDNAPI int idna_to_unicode_8zlz | ( | const char * | input,
|  | char ** | output,
|  | int | flags
| ) |  |

idna_to_unicode_8zlz:

Parameters

  input | zero-terminated UTF-8 string.
  output | pointer to newly allocated output string encoded in the current locale's character set.
  flags | an Idna_flags value, e.g., IDNA_ALLOW_UNASSIGNED or IDNA_USE_STD3_ASCII_RULES.

Convert possibly ACE encoded domain name in UTF-8 format into a string encoded in the current locale's character set. The domain name may contain several labels, separated by dots. The output buffer must be deallocated by the caller.

Return value: Returns IDNA_SUCCESS on success, or error code.

Definition at line 784 of file idna.c.

## ◆ idna_to_unicode_lzlz()

IDNAPI int idna_to_unicode_lzlz | ( | const char * | input,
|  | char ** | output,
|  | int | flags
| ) |  |

idna_to_unicode_lzlz:

Parameters

  input | zero-terminated string encoded in the current locale's character set.
  output | pointer to newly allocated output string encoded in the current locale's character set.
  flags | an Idna_flags value, e.g., IDNA_ALLOW_UNASSIGNED or IDNA_USE_STD3_ASCII_RULES.

Convert possibly ACE encoded domain name in the locale's character set into a string encoded in the current locale's character set. The domain name may contain several labels, separated by dots. The output buffer must be deallocated by the caller.

Return value: Returns IDNA_SUCCESS on success, or error code.

Definition at line 819 of file idna.c.